% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ctStanTIpredMarginal.R
\name{ctStanTIpredMarginal}
\alias{ctStanTIpredMarginal}
\title{Plot marginal relationships between covariates and parameters for a ctStanFit object.}
\usage{
ctStanTIpredMarginal(fit, tipred, pars, matrices = TRUE, plot = TRUE)
}
\arguments{
\item{fit}{ctStanFit object.}

\item{tipred}{character vector representing which tipreds to use.}

\item{pars}{Character vector of either parameter names, or if matrices=TRUE,
system matrices with optional indices -- e.g, 'DRIFT' or 'DIFFUSION[2,1]'.}

\item{matrices}{Logical, see pars argument.}

\item{plot}{Logical, whether to plot.}
}
\value{
If \code{plot=TRUE}, nothing, otherwise an array that can be used with ctPlotArray.
}
\description{
Plot marginal relationships between covariates and parameters for a ctStanFit object.
}
\examples{
if(w32chk()){#'
ctStanTIpredMarginal(ctstantestfit,pars=c('CINT'),
  matrices=TRUE, tipred=c('TI1'))
}
}
